#include <engine/controls.h>

void
controller_read(port)
int port;
{
	gamepad[port].btn = ~(padbuf[port][2]<<8 | padbuf[port][3]);

	if(padbuf[port][1]>>4 == 7) /* analog controller */
	{
		gamepad[port].rx = padbuf[port][4] - 128;
		gamepad[port].ry = padbuf[port][5] - 128;
		gamepad[port].lx = padbuf[port][6] - 128;
		gamepad[port].ly = padbuf[port][7] - 128;
	}
	else /* normal controller */
	{
		gamepad[port].rx = 0;
		gamepad[port].ry = 0;
		gamepad[port].lx = 0;
		gamepad[port].ly = 0;
	}
}

is_button_pressed(port, button)
int port, button;
{
	if(gamepad[port].btn & button)
	{
		return 1;
	}

	return 0;
}

is_button_just_pressed(port, button)
int port, button;
{
	/* if button is currently pressed AND you were not pressing it previously */
	if( (gamepad[port].btn & button) && !(gamepad[port].btnprev & button) )
	{
		gamepad[port].btnprev += button; /* button value now recorded */
		return 1;
	}

	/* if button is NOT currently pressed AND you were pressing it previously */
	else if( !(gamepad[port].btn & button) && (gamepad[port].btnprev & button) )
	{
		gamepad[port].btnprev -= button; /* button value removed */
	}

	return 0;
}

